package org.bdware.sc.controlproxy.Hello;

import com.google.gson.Gson;
import com.google.gson.JsonElement;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bdware.doip.audit.EndpointConfig;
import org.bdware.doip.audit.client.AuditDoipClient;
import org.bdware.doip.audit.client.AuditIrpClient;
import org.bdware.doip.audit.config.TempConfigStorage;
import org.bdware.doip.audit.writer.AuditConfig;
import org.bdware.doip.audit.writer.AuditType;
import org.bdware.doip.auditrepo.AutoAuditDO;
import org.bdware.doip.codec.doipMessage.DoipMessage;
import org.bdware.doip.endpoint.client.ClientConfig;
import org.bdware.irp.exception.IrpClientException;
import org.bdware.irp.stateinfo.StateInfoBase;
import org.bdware.sc.engine.JSONTool;


public class Hello {
    private static final Logger LOGGER = LogManager.getLogger(Hello.class);

    public static void main(String[] args) {
        LOGGER.info("abc");
    }

    static EndpointConfig endpointConfig;

    public static void init(Object obj) {
        String defaultConfg= "{\"routerURI\":\"127.0.0.1:2041\"}";
        if (obj==null){
           return;
        }

        if (obj instanceof String) {
            if (!((String) obj).startsWith("{")){

            }
            TempConfigStorage storage = new TempConfigStorage((String) obj);
            endpointConfig = storage.loadAsEndpointConfig();
        } else {
            JsonElement je = JSONTool.convertMirrorToJson(obj);
            TempConfigStorage storage = new TempConfigStorage(je.toString());
            endpointConfig = storage.loadAsEndpointConfig();
        }
    }

    public static String getConfig() {
        return new Gson().toJson(endpointConfig);
    }

    public static String call() {
        return "hello..dafdskf";
    }

    public static String getAuditType(String doid) {
        AuditIrpClient irpClient = new AuditIrpClient(endpointConfig);
        AuditConfig auditConfig = irpClient.getAuditConfig();
        AuditDoipClient client = new AuditDoipClient(auditConfig);
        ClientConfig config = null;
        try {
            StateInfoBase result = irpClient.resolve(doid);
            config = new ClientConfig(result.getValues("address"));
        } catch (IrpClientException e) {
            e.printStackTrace();
        }
        client.connect(config);
        DoipMessage msg = client.sendMessageSync(AutoAuditDO.getRepoAuditType(doid));
        AuditType type = AutoAuditDO.getAuditTypeFromRespMessage(msg);
        LOGGER.info(type);
        return type.toString();
    }
}